package com.qtzl.sample.config;

import cn.com.taiji.common.manager.AbstractManager;
import com.txffp.api.core.manager.context.AppContextManager;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;

import java.util.concurrent.ThreadPoolExecutor;

@Configuration
public class ContextConfig extends AbstractManager {


	@Bean
	public AppContextManager appContextManager(ApplicationContext applicationContext) {
		AppContextManager appContextManager = new AppContextManager();
		appContextManager.setApplicationContext(applicationContext);
		return appContextManager;
	}


	@Bean(name="asyncServiceExecutor")
	public ThreadPoolTaskExecutor asyncServiceExecutor(){
	    ThreadPoolTaskExecutor executor = new ThreadPoolTaskExecutor();

	    executor.setCorePoolSize(10);//配置核心线程数

	    executor.setMaxPoolSize(25);//配置最大线程数

	    executor.setQueueCapacity(20);//配置队列大小

	    executor.setThreadNamePrefix("myBootExecutor-");//线程的名称前缀

	    //Caller_runs:不在新线程中执行任务，而是在调用者所在线程执行

	    executor.setRejectedExecutionHandler(new ThreadPoolExecutor.CallerRunsPolicy());

	    executor.initialize();

	    return executor;
	}

}
