package com.qtzl.sample.config;

import cn.com.taiji.common.manager.AbstractManager;
import cn.com.taiji.common.repo.jpa.MyJpaRespositoryFactoryBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.context.annotation.AdviceMode;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import javax.sql.DataSource;

/**
 *
 *
 * @author 杨境
 *
 */
@EntityScan(value = "com.qtzl.sample.dao.entity")
@EnableTransactionManagement(proxyTargetClass = true,mode = AdviceMode.ASPECTJ)
@EnableJpaRepositories(basePackages ={"com.qtzl.sample.dao.repo"},repositoryFactoryBeanClass = MyJpaRespositoryFactoryBean.class)
@Configuration
public class DruirdConfig extends AbstractManager{

	@Autowired
	private DataSource dataSource;

	@Value("${spring.datasource.dialect}")
	private String dialect;

	@Value("${spring.datasource.enableDrds}")
	private boolean enableDrds;



	@Bean
	public JdbcTemplate jdbcTemplate() {
		return new JdbcTemplate(dataSource);
	}




}
