package com.qtzl.sample.dao.repo.jpa;

import cn.com.taiji.common.repo.jpa.AbstractJpaRepo;
import com.qtzl.sample.dao.entity.TempLi;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Map;

public interface SfRepo extends AbstractJpaRepo<TempLi, String> {

    @Query(nativeQuery = true, value = "" +
            "SELECT " +
            " a.vehicleId as vehicleId, " +
            " b.agreementNumber as agreementNumber, " +
            " a.bankName as bankName, " +
            " a.confirmTime as confirmTime, " +
            " c.promoterNum as promoterNum, " +
            " c.promoterChannelNum as promoterChannelNum, " +
            " d.userIdNo as userIdNo, " +
            " d.userName as userName, " +
            " d.department as department" +
            " FROM " +
            " t_yw_contract_info a, " +
            " t_yw_icbc_contractdetail b, " +
            " t_yw_order_info c, " +
            " t_yw_user_info d " +
            " WHERE " +
            " a.contractDetailId = b.oid " +
            " AND a.orderId = " +
            " c.id " +
            " AND c.userId = d.id " +
            " AND " +
            " a.id = b.msgId " +
            " and " +
            " b.agreementNumber= ?1 " +
            " ORDER BY " +
            " a.confirmTime ASC;" +
            "")
    public Map<String, String> query1(String agreementId);

    @Query(nativeQuery = true, value = "" +
            "SELECT " +
            " a.vehicleId as vehicleId, " +
            " b.agreementNumber as agreementNumber, " +
            " a.bankName as bankName, " +
            " a.confirmTime as confirmTime, " +
            " c.promoterNum as promoterNum, " +
            " c.promoterChannelNum as promoterChannelNum, " +
            " d.userIdNo as userIdNo, " +
            " d.userName as userName, " +
            " d.department as department" +
            " FROM " +
            " t_yw_contract_info_log a, " +
            " t_yw_icbc_contractdetail b, " +
            " t_yw_order_info c, " +
            " t_yw_user_info d " +
            " WHERE " +
            " a.contractDetailId = b.oid " +
            " AND a.orderId = " +
            " c.id " +
            " AND c.userId = d.id " +
            " AND " +
            " a.id = b.msgId " +
            " and " +
            " b.agreementNumber= ?1 " +
            "")
    public Map<String, String> query2(String agreementId);

    @Query(nativeQuery = true, value = "" +
            "SELECT " +
            " a.vehicleId as vehicleId, " +
            " b.agreementNumber as agreementNumber, " +
            " a.bankName as bankName, " +
            " a.confirmTime as confirmTime, " +
            " c.promoterNum as promoterNum, " +
            " c.promoterChannelNum as promoterChannelNum, " +
            " d.userIdNo as userIdNo, " +
            " d.userName as userName, " +
            " d.department as department" +
            " FROM " +
            " t_yw_contract_info_copy a, " +
            " t_yw_icbc_contractdetail b, " +
            " t_yw_order_info c, " +
            " t_yw_user_info d " +
            " WHERE " +
            " a.contractDetailId = b.oid " +
            " AND a.orderId = " +
            " c.id " +
            " AND c.userId = d.id " +
            " AND " +
            " a.id = b.msgId " +
            " and " +
            " b.agreementNumber= ?1 " +
            "")
    public Map<String, String> query3(String agreementId);

}
